from flask import (
    Blueprint, redirect, render_template, request, session, url_for
)

from config import CONFIG 
from create_db import Deck, Card, get_session

from deck import get_deck, probabilistic_deck_generator
from settings import get_settings
from auth import login

bp = Blueprint('menu', __name__, url_prefix='/menu')

@bp.route("/", methods=("GET", "POST"))
def index():
    deck_status = []
    dbsession = get_session()
    if 'user_id' not in session:
        return login()
    
    if 'user_id' in session:
        user_id = session['user_id']
        username = session['username']
        print(username)

        old_deck = dbsession.query(Deck).filter(Deck.completed == 0, Deck.owner_id == user_id).all()
        if old_deck != []:
            deck_status = "old"

        if request.method == "POST":
            action = request.form.get("menu", False) #internetna rešitev, nevem kako, ampak dela, tj. dobi info iz meni buttonov
            print(action)
            if action == "new_session":
                # @TODO tu bi moral preveriti če je kak unfinished deck, potem bi pisalo continiue, namesto new
                old_deck = dbsession.query(Deck).filter(Deck.completed == 0, Deck.owner_id == user_id).all()
                if old_deck != []:
                    return redirect(url_for("deck"))

                #preverimo če so sploh karte v collectionu
                print("userID", user_id)
                c = dbsession.query(Card).filter(Card.owner_id == user_id).all()
                #print(dbsession.query(Card).all())
                #print(c)
                if c == []:
                    print("ne najdem collectiona")
                    return render_template("error/no_cards_in_collection.html", username=username)
                
                #ustvari novi vnos v Deck
                deck = probabilistic_deck_generator(user_id, 5, 5)
                cards_by_id = get_deck(deck)
                if cards_by_id == None:
                    print("Deck is none")
                    return render_template(index())
                else:
                    number_of_cards = len(cards_by_id.split(","))
                    
                    print(cards_by_id, number_of_cards)
                    deck = Deck(cards_by_id=cards_by_id, owner_id=user_id, number_of_cards=number_of_cards, current_card=0, completed=False)
                    dbsession.add(deck)
                    dbsession.commit()
                    dbsession.close()

                    return redirect(url_for("deck"))
            elif action == "matches":
                return redirect(url_for("matches.index"))
            elif action == "upload":
                return redirect(url_for("upload.index"))
            elif action == "settings":
                #settings = get_settings(user_id)
                return render_template("settings.html", username=username, user_id=user_id)
            elif action == "instructions":
                return render_template("instructions.html", username=username, user_id=user_id)
            elif action == "about":
                return render_template("about.html", username=username, user_id=user_id)


    return render_template("menu/menu.html", username=username, deck_status=deck_status)
